###################################################
### chunk number 1: 
###################################################
options(prompt= "R> ", useFancyQuotes = FALSE)


###################################################
### chunk number 2: 
###################################################
library("Formula")
f <- Formula(y ~ x11 + x12  | x21 + x22 | x31 + x32)


###################################################
### chunk number 3: 
###################################################
data("tobin", package = "survival")
head(tobin, 3)


###################################################
### chunk number 4: 
###################################################
f <- Formula(durable ~ age | age + quant | quant)


###################################################
### chunk number 5: 
###################################################
S <- model.matrix(f, data = tobin, rhs = 1)
X <- model.matrix(f, data = tobin, rhs = 2)
P <- model.matrix(f, data = tobin, rhs = 3)
head(X,3)
head(S,3)
head(P,3)


###################################################
### chunk number 6: 
###################################################
library("mhurdle")


###################################################
### chunk number 7: 
###################################################
model12i <- mhurdle(durable~age+quant|age+quant|age+quant, tobin, dist="n", method="bfgs")


###################################################
### chunk number 8: 
###################################################
model5 <- mhurdle(durable~0|age+quant|0, tobin, dist="n", method="nr")


###################################################
### chunk number 9: 
###################################################
model3i <- mhurdle(durable~age+quant|age+quant|0, tobin, dist="l")


###################################################
### chunk number 10: 
###################################################
model6 <- mhurdle(durable~0|age+quant|age+quant, tobin, dist="l")


###################################################
### chunk number 11: 
###################################################
model8i <- mhurdle(durable~age+quant|age+quant|0, tobin, dist="n")


###################################################
### chunk number 12: 
###################################################
model8d <- update(model8i, corr = TRUE)


###################################################
### chunk number 13: 
###################################################
summary(model8i)


###################################################
### chunk number 14: 
###################################################
coef(model12i, "reg")
coef(model12i, "sel")
coef(model12i, "sigma")
coef(summary(model12i), "ifr")
vcov(model12i, "reg")


###################################################
### chunk number 15: 
###################################################
logLik(model12i)
logLik(model12i, which = "positive")
logLik(model12i, naive = TRUE, which = "zero")


###################################################
### chunk number 16: 
###################################################
head(fitted(model12i))


###################################################
### chunk number 17: 
###################################################
pr <- predict(model12i,newdata = data.frame(durable = c(0,1,0),
                         age = c(50, 32, 48),
                         quant = c(206, 232, 245)))
head(pr)


###################################################
### chunk number 18: 
###################################################
r.squared(model12i,which = "all",type = "regression")


###################################################
### chunk number 19: 
###################################################
r.squared(model12i, type = "mcfadden", which = "all", dfcor = TRUE)


###################################################
### chunk number 20: 
###################################################
vuongtest(model6, model8d)


###################################################
### chunk number 21: 
###################################################
vuongtest(model8d, model8i, type='nested', hyp=TRUE)
vuongtest(model8d, model8i, type='nested', hyp=FALSE)


###################################################
### chunk number 22: 
###################################################
coef(summary(model8d), "rho")


